Cines/Models/Pelicula.cs
using System;
using System.Collections.Generic;
using System.ComponentModel.DataAnnotations.Schema;
using System.Linq;
using System.Web;

namespace Cines.Models
{
    public abstract class Pelicula
    {
        public int ID { get; set; }
        public string Nombre { get; set; }
        public int DuracionMinutos { get; set; }

        public string Sinopsis { get; set; }

        public string ImageUrl { get; set; }

        [NotMapped]
        public HttpPostedFileBase Imagen { get; set; }

        [NotMapped]
        public string MyDiscriminator
        {
            get{ return this.GetType().Name; }
        }

    }
}

Cines/Controllers/FuncionController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using Cines.DAL;
using Cines.Filtros;
using Cines.Models;

namespace Cines.Controllers
{
    [AuthFilter]
    public class FuncionController : Controller
    {
        private CineContext db = new CineContext();

        public ActionResult Index()
        {
            return View();
        }

        // GET: Funcion
        public ActionResult Lista(int? cine)
        {
            if(cine == null)
            {
                return RedirectToAction("ElegirCine");
            }
            if (db.Cines.Find(cine) == null) {
                ViewBag.MensajeError = "Cine no encontrado";
                return View("ErrorFuncion");
            }
            ViewBag.CineNombre = db.Cines.Find(cine).Nombre;

            var funciones = db.Salas
                .Include(sa => sa.Funciones.Select(pe => pe.Pelicula))
                .Where(f => f.CineId == cine);
            var listaFunciones = funciones.ToList();
            funciones.OrderBy(s => s.Funciones.OrderBy(f=>f.Horario));
            return View(funciones);
        }

        

        // GET: Funcion/Details/5
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Funcion funcion = db.Funciones.Find(id);
            if (funcion == null)
            {
                return HttpNotFound();
            }
            return View(funcion);
        }
        public ActionResult ElegirCine()
        {
            ViewBag.Cines = db.Cines.ToList();
            return View();
        }

        public ActionResult ElegirCineCrear()
        {
            ViewBag.Cines = db.Cines.ToList();
            return View();
        }

        // GET: Funcion/Create
        public ActionResult Create(int? cine)
        {
            if(cine == null)
            {
                return RedirectToAction("ElegirCineCrear");
            }
            ViewBag.CineNombre = db.Cines.Find(cine).Nombre;
            ViewBag.Salas = db.Salas.Where(s => s.CineId == cine);
            ViewBag.PeliculasComerciales = db.Peliculas.OfType<PeliculaComercial>().ToList();
            ViewBag.PeliculasDocumentales = db.Peliculas.OfType<PeliculaDocumental>().ToList();


            ViewBag.PeliculaId = new SelectList(db.Peliculas, "ID", "Nombre");
            return View();
        }

        

        // POST: Funcion/Create
        // Para protegerse de ataques de publicación excesiva, habilite las propiedades específicas a las que desea enlazarse. Para obtener 
        // más información vea https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create(Funcion funcion)
        {
            if(db.Peliculas.Find(funcion.PeliculaId).MyDiscriminator == "PeliculaDocumental")
            {
                var salatipo = db.Salas.Find(funcion.SalaId).MyDiscriminator;
                    if(salatipo == "HD") {
                    ViewBag.MensajeError = "Las peliculas documentales no pueden exhibirse en salas HD";
                    return View("ErrorFuncion");
                }
            }

            var dia = funcion.Horario;

            var funcionesDia = db.Funciones.ToList();
            funcionesDia = funcionesDia.Where(f => f.SalaId == funcion.SalaId).ToList();

            var funcionesCargadas = new List<Funcion>();


            foreach(var f in funcionesDia)
            {
                if(f.Horario.Date == dia)
                {
                    funcionesCargadas.Add(f);
                }
                if(f.Horario.Date == dia.AddDays(1) && f.Horario.Hour < 10)
                {
                    funcionesCargadas.Add(f);
                }
            }

            funcionesCargadas = funcionesCargadas.OrderBy(f => f.Horario).ToList();
            //Asumo que como el ejercicio no aclara nada, se pueden crear funciones de días anteriores
            //Sino, sería tan simple como que verifique que el horario sea mayor a now()
            if (!funcionesCargadas.Any() || (funcionesCargadas.Last().Horario.Hour < 10 && funcionesCargadas.Last().Horario.Date == funcion.Horario.Date))
            {
                TimeSpan ts = new TimeSpan(10, 0, 0);
                funcion.Horario = funcion.Horario.Date + ts;
            }
            else
            {
                var ultima = funcionesCargadas.Last();
                var nuevoHorario = ultima.Horario.AddMinutes(db.Peliculas.Find(ultima.PeliculaId).DuracionMinutos);
                nuevoHorario = nuevoHorario.AddMinutes(15);

                TimeSpan ts = new TimeSpan(2, 0, 0);
                var horarioLimite = dia + ts;
                horarioLimite = horarioLimite.AddDays(1);

                if (nuevoHorario < horarioLimite)
                {
                    funcion.Horario = nuevoHorario;
                }
                else
                {
                    ViewBag.MensajeError = "No quedan horarios disponible para esa fecha";
                    return View("ErrorFuncion");
                }

                
            }

            //funcionesDia.Where();
            var cineId = db.Salas.Find(funcion.SalaId).CineId;
            if (ModelState.IsValid)
            {
                db.Funciones.Add(funcion);
                db.SaveChanges();
                return RedirectToAction("Lista",new {cine = cineId });

            }
            ViewBag.PeliculaId = new SelectList(db.Peliculas, "ID", "Nombre", funcion.PeliculaId);
            return RedirectToAction("Lista", new { cine = cineId });
        }


        /*

         // GET: Funcion/Delete/5
         public ActionResult Delete(int? id)
         {
             if (id == null)
             {
                 return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
             }
             Funcion funcion = db.Funciones.Find(id);
             if (funcion == null)
             {
                 return HttpNotFound();
             }
             return View(funcion);
         }

         // POST: Funcion/Delete/5
         [HttpPost, ActionName("Delete")]
         [ValidateAntiForgeryToken]
         public ActionResult DeleteConfirmed(int id)
         {
             Funcion funcion = db.Funciones.Find(id);
             db.Funciones.Remove(funcion);
             db.SaveChanges();
             return RedirectToAction("Lista");
         }*/


        public ActionResult BorrarTodas(int? sala)
        {
            if (sala == null)
            {
                ViewBag.MensajeError = "Sala no ingresada";
                return View("ErrorFuncion");
            }

            var salaAElminar = db.Salas.Find(sala);
            salaAElminar.Funciones = db.Funciones.Where(f => f.SalaId == salaAElminar.Id)
                .Include(fu => fu.Pelicula).ToList();
                //sa.Funciones.Select(pe => pe.Pelicula));

            if (salaAElminar == null)
            {
                ViewBag.MensajeError = "Sala no encontrada";
                return View("ErrorFuncion");
            }
            if (salaAElminar.Funciones == null)
            {
                ViewBag.MensajeError = "La sala no tiene funciones";
                return View("ErrorFuncion");
            }

            return View(salaAElminar);
        }

        [HttpPost, ActionName("BorrarTodas")]
        public ActionResult BorrarTodas(int sala)
        {


            var salaAElminar = db.Salas.Find(sala);

            db.Funciones.RemoveRange(db.Funciones.Where(f => f.SalaId == sala));
            db.SaveChanges();
            return RedirectToAction("Lista", new { cine = salaAElminar.CineId });
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}

Cines/Controllers/PeliculasController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using Cines.DAL;
using Cines.Filtros;
using Cines.Models;

namespace Cines.Controllers
{
    public class PeliculasController : Controller
    {
        private CineContext db = new CineContext();

        // GET: Peliculas
        public ActionResult Index()
        {
            var peliculas = db.Peliculas.ToList().OrderBy(Pelicula => Pelicula.Nombre);
            ViewBag.Cines = db.Cines.ToList();

            return View(peliculas.ToList());
        }

        // GET: Peliculas/Details/5
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }

            var comerciales = db.Peliculas.OfType<PeliculaComercial>();
            var documentales = db.Peliculas.OfType<PeliculaDocumental>();

            foreach (var pel in comerciales)
            {
                if (pel.ID == id)
                {
                    return RedirectToAction("Details", "PeliculaComercial", new { id });
                }
            }
            foreach (var pel in documentales)
            {
                if (pel.ID == id)
                {
                    return RedirectToAction("Details", "PeliculaDocumental", new { id });
                }
            }
            ViewBag.MensajeError = "Película no encontrada";
            return View("ErrorPelicula");
        }

        // GET: Peliculas/Create
        [AuthFilter]
        public ActionResult Create()
        {
            return View();
        }

        [HttpPost]
        [AuthFilter]
        public ActionResult CreateComercial()
        {
            return RedirectToAction("Create", "PeliculaComercial");
        }

        [HttpPost]
        public ActionResult CreateDocumental()
        {
            return RedirectToAction("Create","PeliculaDocumental");
        }


        [AuthFilter]
        public ActionResult ListaEliminar()
        {
            var peliculas = db.Peliculas.ToList().OrderBy(Pelicula => Pelicula.Nombre);

            return View(peliculas.ToList());
        }

        // GET: Peliculas/Delete/5
        [AuthFilter]
        public ActionResult Delete(int? id)
        {   //Si quiero eliminar cada una
            
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            /*
            Pelicula pelicula = db.Peliculas.Find(id);
            if (pelicula == null)
            {
                return HttpNotFound();
            }
            return View(pelicula);*/

            //Esto era por si quería que cada uno eliminara su película


            //CHEQUEAR SI ESTÁ EN EXHIBICIÓN O NO


            var funciones = db.Funciones.ToList();

            foreach (var f in funciones)
            {
                if (f.PeliculaId == id)
                {
                    ViewBag.MensajeError = "La pelicula esta en cartelera, por lo que no puede eliminarse";
                    return View("ErrorPelicula");
                }
            }

            var comerciales = db.Peliculas.OfType<PeliculaComercial>();
            var documentales = db.Peliculas.OfType<PeliculaDocumental>();


            foreach (var pel in comerciales)
            {
                if (pel.ID == id)
                {
                    return RedirectToAction("Delete", "PeliculaComercial", new { id });
                }
            }
            foreach (var pel in documentales)
            {
                if (pel.ID == id)
                {
                    return RedirectToAction("Delete", "PeliculaDocumental", new { id });
                }
                
            }
            ViewBag.MensajeError = "Película no encontrada";
            return View("ErrorPelicula");


        }

        [AuthFilter]
        public ActionResult Administrar()
        {
            return View();
        }

        /*
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {
            Pelicula pelicula = db.Peliculas.Find(id);
            String UrlImagen = pelicula.ImageUrl;
            System.IO.File.Delete(UrlImagen);
            db.Peliculas.Remove(pelicula);
            db.SaveChanges();
            return RedirectToAction("Index");
        }
        */

        public ActionResult Buscar(int cine,String palabra)
        {
            var palabratl = palabra.ToLower();
            if (db.Cines.Find(cine) == null)
            {
                ViewBag.MensajeError = "Cine no encontrado";
                return View("ErrorPelicula");
            }

            ViewBag.Cines = db.Cines.ToList();

            var peliculas = db.Salas
                .Include(sa => sa.Funciones.Select(pe => pe.Pelicula))
                .Where(f => f.CineId == cine);

            var listaPeliculas = new HashSet<Pelicula>();

            foreach(var p in peliculas)
            {
                foreach (var f in p.Funciones)
                {
                    if (f.Pelicula.Nombre.ToLower().Contains(palabratl))
                    {
                        listaPeliculas.Add(f.Pelicula);
                    }
                    //Me doy cuenta de todo lo que está mal en esta parte (romper la abstracción,reutilizar código, etc) pero no encontré la forma de que me trajera los temas
                    //con la película, con lo cual quedaba en null ese campo y no podía utilizarlo desde el model
                    if (f.Pelicula.MyDiscriminator == "PeliculaDocumental")
                    {
                        var pd = (PeliculaDocumental)f.Pelicula;
                        pd.Tema = db.Temas.Find(pd.TemaId);
                        if (pd.Tema.Nombre.ToLower().Contains(palabratl))
                        {
                            listaPeliculas.Add(f.Pelicula);
                        }
                    }

                    if(f.Pelicula.MyDiscriminator == "PeliculaComercial")
                    {
                        var pd = (PeliculaComercial)f.Pelicula;
                        if (pd.Actores.ToLower().Contains(palabratl))
                        {
                            listaPeliculas.Add(f.Pelicula);
                        }
                    }
                }
            }

            return View("Index", listaPeliculas);
        }
         

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }
    }
}

Cines/Views/Peliculas/Administrar.cshtml
@{
    ViewBag.Title = "ADMINISTRAR";
}

<h2>ADMINISTRAR</h2>

<form method="post" action="@Url.Action("Create")">
    <button class="btn btn-large btn-block btn-primary" type="submit">CREAR PELÍCULA</button>
</form>
<br />

<form method="post" action="@Url.Action("ListaEliminar")">
    <button class="btn btn-large btn-block" type="submit">ELIMINAR PELÍCULA</button>
</form>
<br />

<form method="post" action="@Url.Action("Index","Funcion")">
    <button class="btn btn-large btn-block btn-primary" type="submit">FUNCIONES</button>
</form>

Cines/Views/Peliculas/Create.cshtml
@model Cines.Models.Pelicula

@{
    ViewBag.Title = "Create";
}

<h2>Create</h2>

<form method="post" action="@Url.Action("CreateDocumental")">
    <button class="btn btn-large btn-block btn-primary" type="submit">DOCUMENTAL</button>
</form>
<br />

<form method="post" action="@Url.Action("CreateComercial")">
    <button class="btn btn-large btn-block" type="submit">COMERCIAL</button>
</form>

<br />


<div>
    <a href="/Peliculas/Administrar">Volver</a>
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

Cines/Views/Peliculas/Delete.cshtml
@model Cines.Models.Pelicula

@{
    ViewBag.Title = "Delete";
}

<h2>Delete</h2>

<h3>Are you sure you want to delete this?</h3>
<div>
    <h4>Pelicula</h4>
    <hr />
    <dl class="dl-horizontal">
        <dt>
            @Html.DisplayNameFor(model => model.Nombre)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.Nombre)
        </dd>

        <dt>
            @Html.DisplayNameFor(model => model.DuracionMinutos)
        </dt>

        <dd>
            @Html.DisplayFor(model => model.DuracionMinutos)
        </dd>

    </dl>

    @using (Html.BeginForm()) {
        @Html.AntiForgeryToken()

        <div class="form-actions no-color">
            <input type="submit" value="Delete" class="btn btn-default" /> |
            <a href="/Peliculas/ListaEliminar">Volver</a>
        </div>
    }
</div>

Cines/Views/Peliculas/Index.cshtml
@model IEnumerable<Cines.Models.Pelicula>
@Scripts.Render("~/bundles/jquery")

@{
    ViewBag.Title = "Index";
}
<style>
    a {
        text-align:right;
    }
</style>
<br />

<div class="container" style="text-align:center">
    <form action="/Peliculas/buscar" method="get" novalidate="novalidate">
        <div class="row">
            <div class="col-lg-12">
                <div class="row">
                    <div class="col-lg-3 col-md-3 col-sm-12 p-0">
                        <select class="form-control search-slt" id="cine" required name="cine">
                            @foreach(var c in ViewBag.Cines)
                            {
                                <option value="@c.Id">@c.Nombre</option>
                            }

                        </select>
                    </div>
                    <div class="col-lg-3 col-md-3 col-sm-12 p-0">
                        <input type="text" class="form-control search-slt" placeholder="Ingrese Título/Actor/Tema" id="palabra" name="palabra">
                    </div>

                    <div class="col-lg-3 col-md-3 col-sm-12 p-0">
                        <button type="submit" class="btn btn-danger wrn-btn">BUSCAR</button>
                    </div>
                </div>
            </div>
        </div>
    </form>
</div>
<br />
<hr />

<h2 style="text-align:center">Películas</h2>

<table class="table table-bordered" style="border-style:double;border-color:black">
    <tr>
        <th style="text-align:center;width:120px">
            Imagen
        </th>
        <th style="text-align:center">
            @Html.DisplayNameFor(model => model.Nombre)
        </th>
    </tr>

    @foreach (var item in Model)
    {
        <tr>
            <td>
                <img src="@Url.Content(item.ImageUrl)" alt="Image" height="180" width="120" />
            </td>
            <td style="vertical-align:middle;text-align:center">
                <a></a>
                <p style="font-weight:bold">@Html.ActionLink(item.Nombre, "Details", new { id = item.ID }, new {style="color:white" })</p>
                <p style="display:none">@Html.DisplayFor(modelItem => item.MyDiscriminator)</p>

            </td>

        </tr>
    }

</table>

<script>
    $('tr:contains("PeliculaComercial")').css("background-color", "#B32F13");
    $('tr:contains("PeliculaDocumental")').css("background-color", "#265D02");
</script>

Cines/Views/Peliculas/ListaEliminar.cshtml
@model IEnumerable<Cines.Models.Pelicula>
@Scripts.Render("~/bundles/jquery")

@{
    ViewBag.Title = "Index";
}
<style>
    a {
        text-align:right;
    }
</style>
<h2 style="text-align:center">Películas</h2>

<table class="table table-bordered" style="border-style:double;border-color:black">
    <tr>
        <th style="text-align:center;width:120px">
            Imagen
        </th>
        <th style="text-align:center">
            @Html.DisplayNameFor(model => model.Nombre)
        </th>
        <th style="text-align:center">
            Acción
        </th>
    </tr>

    @foreach (var item in Model)
    {
        <tr>
            <td>
                <img src="@Url.Content(item.ImageUrl)" alt="Image" height="180" width="120" />
            </td>
            <td style="vertical-align:middle;text-align:center">
                <a></a>
                <p style="color:white">@item.Nombre</p>
                <p style="display:none">@Html.DisplayFor(modelItem => item.MyDiscriminator)</p>

            </td>
            <td style="vertical-align:middle;text-align:center">
                <a style="font-weight:bold;color:white" href="@Url.Action("Delete", new {id = item.ID })">Eliminar</a>
            </td>

        </tr>
    }

</table>

<script>
    $('tr:contains("PeliculaComercial")').css("background-color", "#B32F13");
    $('tr:contains("PeliculaDocumental")').css("background-color", "#265D02");
</script>